with Ada.Command_Line;
with Text_Io;
with Simple_Xml.Xml_Io;

procedure Dump_Xml is
  use Simple_Xml.Xml_Io;
  use Text_Io;
  procedure Open_Node (Tag        : in String;
                       Attributes : in Xml_Attributes;
                       Value      : in String;
                       Depth      : in Integer) is
  begin
    Put_Line ((1 .. Depth => ' ') & "New node");
    Put_Line ((1 .. Depth => ' ') & "  Tag = " & Tag);
    Put_Line ((1 .. Depth => ' ') & "  Val = " & Value);
    for I in Attributes'range
    loop
      Put_Line ((1 .. Depth => ' ') & "    Attrib : " &
        Attribute_Name (Attributes(I)) & ":" & 
        Attribute_Value (Attributes(I)));
    end loop;
  end Open_Node;

  procedure Close_Node (Depth : in Integer)  is
  begin
    Put_Line ((1 .. Depth => ' ') & "Closing node");
  end Close_Node;

  procedure Note_Version (Version  : in String) is
  begin
    Put_Line ("Version is " & Version);
  end Note_Version;

  procedure Note_Encoding (Encoding  : in String) is
  begin
    Put_Line ("Encoding is " & Encoding);
  end Note_Encoding;

  procedure On_Error is
  begin
    null;
  end On_Error;

  procedure Parse_File is new Parse (Open_Node, Close_Node, Note_Version, Note_Encoding, On_Error);

begin
  Parse_File (File_Name => Ada.Command_Line.Argument (1));
end Dump_Xml;
