-- Sample usage of Narrow_Xml to generate a XML file
--with Simple_Xml.Xml_Io;
with Simple_Xml.Wide_Xml_Io;
with Text_Io;

procedure Gen_Form is
  use Simple_Xml.Wide_Xml_Io;
  --use Simple_Xml.Xml_Io;

  Writer : Xml_Writer;      -- XML File writer

  function To_Attributes
    (Left   : Integer;
     Top    : Integer;
     Width  : Integer;
     Height : Integer) return Xml_Attributes is
    Attribs : Xml_Attributes (1 .. 4);
  begin
    Attribs (1) := Attribute ("Left",   Integer'wide_image(Left));
    Attribs (2) := Attribute ("Top",    Integer'wide_image(Top));
    Attribs (3) := Attribute ("Width",  Integer'wide_image(Width));
    Attribs (4) := Attribute ("Height", Integer'wide_image(Height));
    return Attribs;
  end To_Attributes;

  procedure Add_Button
    (Title  : in Wide_String;
     Left   : Integer;
     Top    : Integer;
     Width  : Integer;
     Height : Integer) is
  begin
    Open_Node  (Writer, "BUTTON", To_Attributes (Left, Top, Width, Height));
    Open_Node  (Writer, "TITLE");
    Set_Value  (Writer, Title);
    Close_Node (Writer);
    Close_Node (Writer);
  end Add_Button;
     
begin

  Text_Io.Put ("Generating Sample_Form.Xml ... ");

  Create (Writer, "Sample_Form.xml");  -- Init writer
  Open_Node  (Writer, "FORM", To_Attributes (10, 10, 200, 150));  -- Add a new form

  Open_Node  (Writer, "TITLE");                                   -- Add a title
  Set_Value  (Writer, "Narrow XML tester");
  Close_Node (Writer);

  -- Add buttons
  Add_Button ("Hello", 10, 10, 80, 30);
  Add_Button ("Bye !!", 10, 50, 80, 30);
  Add_Button (" bientt", 100, 10, 80, 30);   --- accent check
  Add_Button ("Au revoir", 100, 50, 80, 30);

  Close_Node (Writer);                 -- Close the form
  Close      (Writer);                 -- Close the writer

  Text_Io.Put_Line ("[Done]");

end Gen_Form;

